//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include    <shellapi.h>
#pragma hdrstop

#include "UnitFile.h"
#include "UnitMain.h"
#include "UnitLib.h"
#include "UnitHint.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormFile *FormFile;
//---------------------------------------------------------------------------
__fastcall TFormFile::TFormFile(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::FormCreate(TObject *Sender)
{
	FormMain->FormInit(Sender);		// vȌ
    								// ŌɎ쐬tH[ɒu
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::WMDropFiles(TWMDropFiles Msg)
{
	FormMain->WMDropFiles(Msg);
    ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::ChgFileName(AnsiString NewName)
{
	LPathName LPathName(NewName);
    DirectoryListBox1->Directory = LPathName.GetPath();
    EditSaveName->Text = LPathName.GetName();
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::ComboBoxFilterChange(TObject *Sender)
{
	FileListBox1->Mask = ComboBoxFilter->Text;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::RadioGroupMultiClick(TObject *Sender)
{
	int *iSelNr, iSelCount, i, j;

	if( (iSelCount = FileListBox1->SelCount) > 0) {
		iSelNr = (int*)calloc(sizeof(int), iSelCount);
		if(iSelNr == NULL) { LShowMessage("܂"); return; }	////////
    	for(i = 0, j = 0; i < FileListBox1->Items->Count; i++) {
			if(FileListBox1->Selected[i])
       	    	iSelNr[j++] = i;
        }
	}
	FileListBox1->ExtendedSelect = (RadioGroupMulti->ItemIndex == 0);
	for(i = 0; i < iSelCount; i++) {
		FileListBox1->Selected[iSelNr[i]] = true;
	}
	if(iSelCount > 0) free(iSelNr);
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::ButtonAllClick(TObject *Sender)
{
    for(int i = 0; i < FileListBox1->Items->Count; i++)
    	FileListBox1->Selected[i] = true;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::ButtonClearClick(TObject *Sender)
{
    for(int i = 0; i < FileListBox1->Items->Count; i++)
    	FileListBox1->Selected[i] = false;

}
//---------------------------------------------------------------------------
AnsiString __fastcall TFormFile::ListFileName(int Index) {
	AnsiString astr;

	astr = FormFile->FileListBox1->Directory;
    if( *(astr.AnsiLastChar()) != '\\' )
      	astr = astr + "\\";
    return astr + FormFile->FileListBox1->Items->Strings[Index];
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::FormShow(TObject *Sender)
{
	if(FileListBox1->SelCount > 0) {
		for(int i = 0; i < FileListBox1->Items->Count; i++) {
			FileListBox1->Selected[i] = false;
   		}
    }
    FileListBox1->ItemIndex = -1;
	//	hbOAhhbv̏
    DragAcceptFiles(Handle, true);
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::FormKeyPress(TObject *Sender, char &Key)
{
	switch(Key) {
    case VK_ESCAPE : ModalResult = mrCancel; break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::SetFileDialog(
    AnsiString asTitle, int iHelpContext,
        bool bMulti, bool bSave, bool bReadOnly, bool bFileList,
        AnsiString asMask, AnsiString asFilters,
        AnsiString asOkBtn, AnsiString asOkHint)
{
	FormFile->Caption = asTitle;
    FormFile->HelpContext = iHelpContext;
	FormFile->Top = FormMain->Top + 8;
    FormFile->Left = FormMain->Left + 24;
    FormFile->MultiFile(bMulti);
    FormFile->SaveFile(bSave);
    FormFile->cbReadOnly->Visible = bReadOnly;
    FormFile->FileListBox1->Enabled = bFileList;
    FormFile->FileListBox1->Color= bFileList ? clWindow : clBtnFace;
	FormFile->Filters(asMask,asFilters);
    ButtonOpen->Caption = asOkBtn;
    popOpen->Caption = asOkBtn;
    ButtonOpen->Hint = asOkHint;
    popOpen->Hint = asOkHint;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::MultiFile(bool Multi)
{
    FileListBox1->Height = Multi ? 185 : 273;
	FileListBox1->MultiSelect = Multi;
    ButtonAll->Visible = Multi;
    ButtonClear->Visible = Multi;
    popAll->Enabled = Multi;
    popClear->Enabled = Multi;
    RadioGroupMulti->Visible = Multi;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::SaveFile(bool Save)
{
    if(Save) {
    	FileListBox1->Height = 185 + 32;
    	GroupBoxSaveName->Visible = true;
        EditSaveName->Visible = true;
    } else {
    	GroupBoxSaveName->Visible = false;
        EditSaveName->Visible = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::FileListBox1Change(TObject *Sender)
{
	FileName = FileListBox1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::FileListBox1Click(TObject *Sender)
{
	LPathName LPathName(FileListBox1->FileName);

	FileName = FileListBox1->FileName;
	EditSaveName->Text = LPathName.GetName();
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::FileListBox1DblClick(TObject *Sender)
{
   if(FileListBox1->MultiSelect) {
		for(int i = 0; i < FileListBox1->Items->Count; i++)
    		FileListBox1->Selected[i] = false;
		FileListBox1->Selected[FileListBox1->ItemIndex] = true;
	}
    ButtonOpenClick(Sender);
	ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::cbReadOnlyClick(TObject *Sender)
{
	ReadOnly = cbReadOnly->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::Filters(AnsiString Mask, AnsiString Filters)
{
    ComboBoxFilter->Text = Mask;
    FileListBox1->Mask = Mask;
	ComboBoxFilter->Items->Text = Filters;
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::popOpenClick(TObject *Sender)
{
	ModalResult = mrOk;	
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::popCancelClick(TObject *Sender)
{
	ModalResult = mrCancel;	
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::ButtonOpenClick(TObject *Sender)
{
	if(EditSaveName->Visible) {
		LPathName LPathName(EditSaveName->Text);
        FileName = LPathName.ChgPath(DirectoryListBox1->Directory);
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::FormActivate(TObject *Sender)
{
	if(Visible && FormHint->Visible) FormHint->Hide();
    if(EditSaveName->Visible) EditSaveName->SetFocus();
    else if(FileListBox1->Enabled) FileListBox1->SetFocus();
    else DriveComboBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TFormFile::sbHintClick(TObject *Sender)
{
	if( !(FormHint->Visible) ) {
		if(FormHint->Visible) FormHint->Hide();
		FormHint->Left = Left;
	    FormHint->Top = Top - FormHint->ClientHeight;
		if(FormHint->Top < 0) {
        	FormHint->Top = Top + Height;
            FormHint->Up = true;
        } else FormHint->Up = false;
	    FormHint->LabelHint->Caption = Application->Hint;
		FormHint->Show();
    }
}
//---------------------------------------------------------------------------


