//---------------------------------------------------------------------------
#include <vcl\vcl.h>
//	#include <MMSystem.h>
//	#include	<stdio.h>
#include	<stdlib.h>
#include	<io.h>
#include	<dos.h>
//	#include	<process.h>
//	#include	<errno.h>
#include	<dir.h>
//	#include	<string.h>
#pragma hdrstop

#include "UnitLib.h"
//---------------------------------------------------------------------------
__fastcall LPathName::LPathName(AnsiString PathName)		// tpX^
{
	strcpy(fullpath, PathName.c_str());
	_splitpath(fullpath,drive,dir,node,ext);
}

AnsiString __fastcall LPathName::GetPath()				// pX𓾂i\tj
{
	char buf[_MAX_PATH];

	strcpy(buf, drive);
	return strcat(buf, dir);
}

AnsiString __fastcall LPathName::GetName()				// t@C𓾂
{
	char buf[_MAX_PATH];

	strcpy(buf, node);
	return strcat(buf, ext);
}

AnsiString __fastcall LPathName::GetNode()				// m[h𓾂
{
	return node;
}

AnsiString __fastcall LPathName::GetExt()					// gq𓾂isIhȂj
{
	return ext + 1;
}

AnsiString __fastcall LPathName::ChgPath(AnsiString Path)	// pXւ
{
	char buf[_MAX_PATH];

	strcpy(buf, Path.c_str());
    if( buf[strlen(buf)-1] != '\\' ) strcat(buf, "\\");
    strcat(buf, node);
	return strcat(buf, ext);
}

AnsiString __fastcall LPathName::ChgName(AnsiString Name)	// t@Cւ
{
	char buf[_MAX_PATH];

	strcpy(buf, drive);
    strcat(buf, dir);
	return strcat(buf, Name.c_str());
}

AnsiString __fastcall LPathName::ChgNode(AnsiString Node)	// m[hւ
{
	char buf[_MAX_PATH];

	strcpy(buf, drive);
    strcat(buf, dir);
    strcat(buf, Node.c_str());
	return strcat(buf, ext);
}

AnsiString __fastcall LPathName::ChgExt(AnsiString Ext)	// gqւisIhsvj
{
	char buf[_MAX_PATH];

	strcpy(buf, drive);
    strcat(buf, dir);
    strcat(buf, node);
    if(*(Ext.c_str()) != '.') strcat(buf, ".");
	return strcat(buf, Ext.c_str());
}

AnsiString __fastcall LPathName::Org()					// ̃tpX𓾂
{
	return fullpath;
}

//---------------------------------------------------------------------------
AnsiString __fastcall GetCwd(void)
{
    static char buf[_MAX_PATH];

    getcwd(buf, _MAX_PATH);
    return buf;
}
//---------------------------------------------------------------------------
bool __fastcall isPathExist(AnsiString Path)
{
	return (access(Path.c_str(), 0) == 0);
}
//---------------------------------------------------------------------------
bool __fastcall isFileWritable(AnsiString FileName)
{
	return (access(FileName.c_str(), 02) == 0);
}
//---------------------------------------------------------------------------
int __cdecl argc(void)
{
	return _argc;
}

char * __cdecl argv(int index)
{
	return _argv[index];
}
//---------------------------------------------------------------------------
int __fastcall LSpawn(AnsiString ExeName, AnsiString ParamStr)
{
	/*
	int id = spawnlp(P_NOWAIT, ExeName.c_str(), ExeName.c_str(), ParamStr.c_str(), NULL);
	if(id == -1) {
    	switch(errno) {
        //	case E2BIG   : break;	//	Xg
        //	case EINVAL  : break;	//	ł
		case ENOENT  : LShowMessage(ExeName + "܂"); break;	//	pX܂̓t@CtȂ
		//	case ENOEXEC : break;	//	G[
		case ENOMEM  : LShowMessage("܂"); break;	//	s
		default		 : LShowMessage("vŐNɎs܂");
        }
    }
    */
    int id = WinExec( (LPCSTR)((ExeName + " " + ParamStr).c_str())
						, SW_SHOWNORMAL);
	char *sp = NULL;
    switch(id) {
	case 0: sp = "The system is out of memory or resources."; break;
    case ERROR_BAD_FORMAT : sp = "The .EXE file is invalid (non-Win32 .EXE or error in .EXE image)."; break;
	case ERROR_FILE_NOT_FOUND : sp = "The specified file was not found."; break;
	case ERROR_PATH_NOT_FOUND : sp = "The specified path was not found."; break;
    }
	if(sp) LShowMessage(sp);
    return id;
	/*
	BOOL CreateProcess(

		LPCTSTR lpApplicationName,	// pointer to name of executable module
		LPTSTR lpCommandLine,	// pointer to command line string
		LPSECURITY_ATTRIBUTES lpProcessAttributes,	// pointer to process security attributes
		LPSECURITY_ATTRIBUTES lpThreadAttributes,	// pointer to thread security attributes
		BOOL bInheritHandles,	// handle inheritance flag
		DWORD dwCreationFlags,	// creation flags
		LPVOID lpEnvironment,	// pointer to new environment block
		LPCTSTR lpCurrentDirectory,	// pointer to current directory name
		LPSTARTUPINFO lpStartupInfo,	// pointer to STARTUPINFO
		LPPROCESS_INFORMATION lpProcessInformation 	// pointer to PROCESS_INFORMATION
	);
   */
 }
//---------------------------------------------------------------------------
void __fastcall LShowMessage(AnsiString Msg)
{
	MessageBeep(MB_OK);
    ShowMessage(Msg);
}
//---------------------------------------------------------------------------
void __fastcall LShowInfo(AnsiString Msg, AnsiString Title)
{
	LMessageBox(Msg, Title, MB_OK | MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
int __fastcall LMessageBox(AnsiString Msg, AnsiString Title, Word Flags)
{
	return Application->MessageBox(Msg.c_str(), Title.c_str(), Flags);
}
//---------------------------------------------------------------------------
bool __fastcall isMatchType(AnsiString FileName, AnsiString Filters)
{
	AnsiString Ext;
	char *p, *q;
    bool ret = false;

	Ext = LPathName(FileName).GetExt();
    q = (char *)malloc(Filters.Length() + 1);
    if(q == NULL) { LShowMessage("܂"); return false; }	////////
    strcpy(q, Filters.c_str());
    p = strtok(q, ",.;:|");
	while(p) {
		if( Ext.AnsiCompareIC(p) == 0 ) {
        	ret = true;
            break;
        }
        p = strtok(NULL, ",.;:|");
    }
	free(q);
    return ret;
}
//---------------------------------------------------------------------------
bool __fastcall isShift() {
	return ( (GetKeyState(VK_SHIFT) & 0x8000) != 0 );
}
//---------------------------------------------------------------------------
bool __fastcall isCtrl() {
	return ( (GetKeyState(VK_CONTROL) & 0x8000) != 0 );
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
