//---------------------------------------------------------------------------
#ifndef UnitMainH
#define UnitMainH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\FileCtrl.hpp>
#include <vcl\Menus.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TMainMenu *MainMenu;
	TMenuItem *mnuFile;
	TMenuItem *mnuExit;
	TMenuItem *mnuView;
	TMenuItem *mnuText;
	TMenuItem *mnuGrph;
	TMenuItem *mnuMulti;
	TCheckBox *cbHide;
	TCheckBox *cbFull;
	TMenuItem *mnuLeft;
	TMenuItem *N1;
	TMenuItem *mnuOption;
	TMenuItem *mnuHelp;
	TMenuItem *mnuVersion;
	TMenuItem *mnuHide;
	TMenuItem *mnuFull;
	TTimer *Timer1;
	TMenuItem *mnuWin;
	TMenuItem *mnuWinG;
	TStatusBar *StatusBar1;
	TEdit *EditFileName;
	TListBox *ListBoxDandD;
	TCheckBox *cbNow;
	TMenuItem *mnuNow;
	TMenuItem *mnuWinT;
	TMenuItem *mnuIns;
	TMenuItem *mnuDel;
	TMenuItem *mnuClear;
	TLabel *Label1;
	TMenuItem *N4;
	TMenuItem *mnuRepeat;
	TMenuItem *mnuHint;
	TMenuItem *N5;
	TCheckBox *cbDrag;
	TMenuItem *mnuDrag;
	TMenuItem *mnuBell;
	TMenuItem *mnuDialog;
	TListView *ListView;
	TPanel *Panel1;
	TSpeedButton *sbIns;
	TSpeedButton *sbDel;
	TSpeedButton *sbClear;
	TSpeedButton *sbText;
	TSpeedButton *sbExit;
	TSpeedButton *sbLeft;
	TSpeedButton *sbRight;
	TSpeedButton *sbMulti;
	TCheckBox *cbRepeat;
	TScrollBar *ScrollBarInterval;
	TEdit *EditInterval;
	TPopupMenu *PopupMenu1;
	TMenuItem *popIns;
	TMenuItem *N3;
	TMenuItem *popGrph;
	TMenuItem *popLeft;
	TMenuItem *popMulti;
	TMenuItem *popText;
	TMenuItem *N6;
	TMenuItem *popExit;
	TMenuItem *N7;
	TMenuItem *mnuIndex;
	TMenuItem *mnuKeyword;
	TMenuItem *N8;
    TMenuItem *mnuScreen;
    TMenuItem *mnuPlugin;
    TMenuItem *mnuOpen;
    TMenuItem *mnuSave;
    TMenuItem *N9;
    TMenuItem *N10;
    TMenuItem *N11;
	void __fastcall mnuExitClick(TObject *Sender);


































	void __fastcall mnuTextClick(TObject *Sender);

	void __fastcall mnuGrphClick(TObject *Sender);


	void __fastcall ScrollBarIntervalChange(TObject *Sender);


	void __fastcall cbFullClick(TObject *Sender);




	void __fastcall FormKeyPress(TObject *Sender, char &Key);









	












	
	
	void __fastcall mnuMultiClick(TObject *Sender);

	void __fastcall mnuLeftClick(TObject *Sender);
	






	void __fastcall mnuVersionClick(TObject *Sender);

	void __fastcall Timer1Timer(TObject *Sender);




	void __fastcall mnuHideClick(TObject *Sender);
	void __fastcall cbHideClick(TObject *Sender);
	void __fastcall mnuFullClick(TObject *Sender);
	void __fastcall mnuHintClick(TObject *Sender);



	

	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall mnuWinGClick(TObject *Sender);
	



	







	
	
	













	







	
	
	
	
	void __fastcall StatusBar1DblClick(TObject *Sender);
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	void __fastcall mnuInsClick(TObject *Sender);
	void __fastcall mnuDelClick(TObject *Sender);
	void __fastcall mnuClearClick(TObject *Sender);
	
	
	
	
	void __fastcall mnuNowClick(TObject *Sender);
	void __fastcall cbNowClick(TObject *Sender);
	void __fastcall mnuWinTClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	
	
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall mnuRepeatClick(TObject *Sender);
	void __fastcall cbRepeatClick(TObject *Sender);
	
	
	void __fastcall cbDragClick(TObject *Sender);
	void __fastcall mnuDragClick(TObject *Sender);
	void __fastcall mnuBellClick(TObject *Sender);
	
	void __fastcall mnuDialogClick(TObject *Sender);
	
	void __fastcall ListViewClick(TObject *Sender);
	
	void __fastcall ListViewDblClick(TObject *Sender);
	
	
	void __fastcall ListViewColumnClick(TObject *Sender, TListColumn *Column);
	
	
	void __fastcall ListViewCompare(TObject *Sender, TListItem *Item1,
	TListItem *Item2, int Data, int &Compare);
	
	
	
	
	void __fastcall ListViewKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
	
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	
	
	
	void __fastcall mnuIndexClick(TObject *Sender);
	void __fastcall mnuKeywordClick(TObject *Sender);
	
    
    void __fastcall mnuScreenClick(TObject *Sender);
    
    
    void __fastcall mnuPluginClick(TObject *Sender);
    void __fastcall mnuOpenClick(TObject *Sender);
    void __fastcall mnuSaveClick(TObject *Sender);
    
private:	// [U[錾
	void __fastcall ShowGrph(AnsiString FileName);
	void __fastcall ListViewAdd(AnsiString FullPathName);
    AnsiString __fastcall ListViewName(int index);
    AnsiString __fastcall ListViewPath(int index);
public:		// [U[錾
	__fastcall TFormMain(TComponent* Owner);
    void __fastcall FormInit(TObject *Sender);
    void __fastcall FormExit(TObject *Sender);
	void __fastcall WMDropFiles(TWMDropFiles Msg);
	void __fastcall SetFocusToMenu();
    void __fastcall OutFocusFromMenu();
	void __fastcall ButtonFace();
    void __fastcall ShowHint(TObject *Sender);
    void __fastcall AppDeactivate(TObject *Sender);

BEGIN_MESSAGE_MAP
MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern TFormMain *FormMain;
extern const AnsiString asTextFilter;
extern const AnsiString asTextFilters;
//---------------------------------------------------------------------------
class TWaitCursor {

private:
    TCursor oldc;
public:
    TWaitCursor() : oldc(Screen->Cursor)   { Screen->Cursor = (TCursor)crHourGlass; }
    ~TWaitCursor()                         { Screen->Cursor = oldc; }
};
//---------------------------------------------------------------------------
#undef  BCBDIALOG
//  [Dialogs]OpenDialogSaveDialoggƂ
//  FormMain̓KȂƂTOpenDialogTSaveDialog
//  ꂼOpenDialogCSaveDialogƂOœ\t
//  Wdefine BCBDIALOGƂ 
//---------------------------------------------------------------------------
#endif
