//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
USEFORM("UnitMain.cpp", FormMain);
USERES("EasyView.res");
USEFORM("UnitGrph.cpp", FormGrph);
USEUNIT("UnitLib.cpp");
USEFORM("UnitFile.cpp", FormFile);
USEFORM("UnitText.cpp", FormText);
USEFORM("UnitHint.cpp", FormHint);
USEFILE("HelpCont.h");
USEUNIT("SPI_LOAD.CPP");
USEFORM("UnitBG.cpp", FormBG);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	try
	{
		Application->Initialize();
		Application->ShowMainForm = false;
		Application->Title = "EasyView";
        Application->HelpFile = "EasyView.hlp";
		Application->CreateForm(__classid(TFormMain), &FormMain);
        Application->CreateForm(__classid(TFormHint), &FormHint);
        Application->CreateForm(__classid(TFormBG), &FormBG);
        Application->CreateForm(__classid(TFormGrph), &FormGrph);
        Application->CreateForm(__classid(TFormFile), &FormFile);
        Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	return 0;
}
//---------------------------------------------------------------------------
