//---------------------------------------------------------------------------
#ifndef UnitFileH
#define UnitFileH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\FileCtrl.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
class TFormFile : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TDriveComboBox *DriveComboBox1;
	TDirectoryListBox *DirectoryListBox1;
	TFileListBox *FileListBox1;
	TComboBox *ComboBoxFilter;
	TRadioGroup *RadioGroupMulti;
	TButton *ButtonOpen;
	TButton *ButtonCancel;
	TCheckBox *cbReadOnly;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label4;
	TButton *ButtonAll;
	TButton *ButtonClear;
	TPopupMenu *PopupMenu1;
	TMenuItem *popAll;
	TMenuItem *N1;
	TMenuItem *popOpen;
	TMenuItem *popCancel;
	TMenuItem *popClear;
	TGroupBox *GroupBoxSaveName;
	TEdit *EditSaveName;
	TSpeedButton *sbHint;
	void __fastcall ComboBoxFilterChange(TObject *Sender);
	void __fastcall RadioGroupMultiClick(TObject *Sender);

	

	
	void __fastcall ButtonAllClick(TObject *Sender);
	
	
	void __fastcall FormShow(TObject *Sender);
	void __fastcall ButtonClearClick(TObject *Sender);
	void __fastcall FormKeyPress(TObject *Sender, char &Key);
	
	void __fastcall FileListBox1DblClick(TObject *Sender);
	
	void __fastcall FileListBox1Change(TObject *Sender);
	void __fastcall cbReadOnlyClick(TObject *Sender);
	
	
	void __fastcall popOpenClick(TObject *Sender);
	void __fastcall popCancelClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	
	
	
	
	
	
	
	
	void __fastcall ButtonOpenClick(TObject *Sender);
	void __fastcall FileListBox1Click(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall sbHintClick(TObject *Sender);
    
    
private:	// [U[錾
	void __fastcall WMDropFiles(TWMDropFiles Msg);
	void __fastcall MultiFile(bool Multi);
	void __fastcall SaveFile(bool Save);
public:		// [U[錾
	__fastcall TFormFile(TComponent* Owner);
	void __fastcall ChgFileName(AnsiString NewName);
    AnsiString __fastcall ListFileName(int Index);
    void __fastcall TFormFile::SetFileDialog(
        AnsiString asTitle, int iHelpContext,
        bool bMulti, bool bSave, bool bReadOnly, bool bFileList,
        AnsiString asMask, AnsiString asFilters,
        AnsiString asOkBtn, AnsiString asOkHint);
    void __fastcall Filters(AnsiString Mask, AnsiString Filters);

    AnsiString FileName;
    bool ReadOnly;

BEGIN_MESSAGE_MAP
MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern TFormFile *FormFile;
//---------------------------------------------------------------------------
#endif
