//---------------------------------------------------------------------------
#ifndef UnitGrphH
#define UnitGrphH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
class TFormGrph : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TImage *ImageDisp;
	TPopupMenu *PopupMenu1;
	TMenuItem *popNext;
	TMenuItem *popPrev;
	TMenuItem *popMulti;
	TMenuItem *N1;
	TMenuItem *popMain;
	TMenuItem *popIns;
	TMenuItem *popExit;
	TMenuItem *N2;
	TMenuItem *popSize;
	TMenuItem *popFull;
	TMenuItem *popRepeat;
	TMenuItem *N4;
	
	TMenuItem *popCopy;
	TMenuItem *popDrag;
    TMenuItem *popScreen;
    TMenuItem *popText;
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormHide(TObject *Sender);


	void __fastcall FormResize(TObject *Sender);
	
	void __fastcall popNextClick(TObject *Sender);
	void __fastcall popPrevClick(TObject *Sender);
	void __fastcall popMultiClick(TObject *Sender);
	void __fastcall popMainClick(TObject *Sender);
	void __fastcall popInsClick(TObject *Sender);
	void __fastcall popExitClick(TObject *Sender);
	void __fastcall popFullClick(TObject *Sender);
	
	void __fastcall popSizeClick(TObject *Sender);
	void __fastcall popRepeatClick(TObject *Sender);
	void __fastcall FormKeyPress(TObject *Sender, char &Key);
	void __fastcall popCopyClick(TObject *Sender);
	
	void __fastcall FormActivate(TObject *Sender);
	
	void __fastcall PopupMenu1Popup(TObject *Sender);
	
	
	void __fastcall popDragClick(TObject *Sender);
	
	
	
	
	
	
	
	void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	
    
    void __fastcall ImageDispClick(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    
    
    void __fastcall popScreenClick(TObject *Sender);
    void __fastcall ImageDispDblClick(TObject *Sender);
    void __fastcall popTextClick(TObject *Sender);
    
private:	// [U[錾
	void __fastcall WMDropFiles(TWMDropFiles Msg);
    void __fastcall ShowGrphSub();
	void __fastcall ShowBalloon();
    void __fastcall HideBalloon();
    void __fastcall Origin(int cx, int cy);
public:		// [U[錾
	__fastcall TFormGrph(TComponent* Owner);
    void __fastcall ShowGrph(const AnsiString FileName);
    void __fastcall FullScreen(const bool boolChecked);

BEGIN_MESSAGE_MAP
MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
void __fastcall InitPlugin(AnsiString PathName);
bool __fastcall isCanDisp(AnsiString FileName);
//---------------------------------------------------------------------------
extern TFormGrph *FormGrph;
//---------------------------------------------------------------------------
#endif
