//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\inifiles.hpp>
#include    <shellapi.h>
#include	<stdio.h>
#pragma hdrstop

#include "UnitMain.h"
#include "UnitGrph.h"
#include "UnitLib.h"
#include "UnitFile.h"
#include "UnitText.h"
#include "UnitHint.h"
#include "HelpCont.h"
//---------------------------------------------------------------------------
#undef  USEREG  //  WXgɐݒۑ
#ifdef  USEREG
    #include <registry.hpp>
#endif
//---------------------------------------------------------------------------
#ifdef BCBDIALOG
static AnsiString asPager = "";
static AnsiString asGrphDir, asPlugin = "@", asListDir, asListFile;
static int iFilterIndex = 1;
const AnsiString asGrphFilter = "*.*";
const AnsiString asGrphFilters =
    "摜̧(*.gif;*.jpg;*.bmp)|*.gif;*.jpg;*bmp|"
    "SĂ̧(*.*)|*.*|";
static AnsiString asGrphMask;
const AnsiString asTextFilter =
	"*.txt;*.doc;*.ini";
const AnsiString asTextFilters =
    "÷̧(*.txt;*.doc;*.ini)|*.txt;*.doc;*.ini|"
    "C/C++̧(*.c;*.cpp;*.h;*.hpp)|*.c;*.cpp;*.h;*.hpp|"
    "HTMĻ(*.html;*.htm)|*.html;*.htm|"
    "SĂ̧(*.*)|*.*|";
#else
static AnsiString asPager = "";
static AnsiString asGrphDir, asPlugin, asListDir, asListFile;
const AnsiString asGrphFilter = "*.*";
const AnsiString asGrphFilters =
	"*.*\r\n"
	"*.gif;*.jpg;*.bmp\r\n"
    "*.gif\r\n"
	"*.jpg\r\n"
    "*.bmp\r\n"
    "*.rle\r\n"
    "*.wmf\r\n"
    "*.emf\r\n"
    "*.ico\r\n";
static AnsiString asGrphMask;
const AnsiString asTextFilter =
	"*.txt;*.doc;*.ini";
const AnsiString asTextFilters =
	"*.txt;*.doc;*.ini\r\n"
    "*.c;*.cpp;*.h;*.hpp\r\n"
    "*.*\r\n";
#endif
static bool bDisplayed = false;
#ifndef USEREG
static TIniFile *IniFile;
static AnsiString asIniName;
#endif
const int iColumnNum = 3;
static int iColumnDefWidth[iColumnNum] = { 128, 40, 256 };
static int iColumnTmpWidth[iColumnNum] = { 128, 40, 256 };
static bool bReverse[iColumnNum];
static int iColumnNr;
static int PicNr = 0;
static bool bHelp = false;
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormMain *FormMain;
//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormInit(TObject *Sender)
{
	// vȌ
    //	FormMain, FormGrph, FormHint, FormFile łɍ쐬ĂȂ΂ȂȂ
	LPathName LExeName(Application->ExeName);
#ifdef USEREG
    #define     RegReadInt(key,var)     if(Reg->ValueExists(key))var=Reg->ReadInteger(key)
    #define     RegReadStr(key,var)     if(Reg->ValueExists(key))var=Reg->ReadString(key)
    #define     RegReadBool(key,var)    if(Reg->ValueExists(key))var=Reg->ReadBool(key)

	//	WXg̓ǂݍ
    if(!isShift()) {
        TRegistry *Reg = new TRegistry();
        Reg->RootKey = HKEY_CURRENT_USER;
		//[Frame]
        if( Reg->OpenKey("\\Software\\SojinProject\\EasyView\\Frame", false) ) {
            RegReadInt("Left", Left);
            RegReadInt("Width", Width);
            RegReadInt("Height", Height);
            RegReadInt("Top", Top);
            if( (FormMain->Left + FormMain->Width) > Screen->Width ) FormMain->Left = 0;
	    	if( (FormMain->Width) > Screen->Width) FormMain->Width = Screen->Width;
            if( (FormMain->Top + FormMain->Height) > Screen->Height ) FormMain->Top = 0;
            if( (FormMain->Height) > Screen->Height ) FormMain->Height = Screen->Height;
            RegReadInt("LsColWid0", iColumnTmpWidth[0]);
            RegReadInt("LsColWid1", iColumnTmpWidth[1]);
            RegReadInt("LsColWid2", iColumnTmpWidth[2]);
            Reg->CloseKey();
        }
        //[General]
        if( Reg->OpenKey("\\Software\\SojinProject\\EasyView\\General", false) ) {
            RegReadStr("Path", asGrphDir);
            #ifdef BCBDIALOG
            RegReadInt("Filter", iFilterIndex);
            #else
		    if(isPathExist(asGrphDir)) {
        	    FormFile->DirectoryListBox1->Directory = asGrphDir;
			    FormFile->DriveComboBox1->Drive = FormFile->DirectoryListBox1->Drive;
            }
            #endif
            RegReadStr("GrphMask", asGrphMask);
            if(asGrphMask == "") asGrphMask = asGrphFilter;
            RegReadStr("Pager", asPager);
            RegReadStr("DateFormat", asDateFormat);
            RegReadStr("Plugin", asPlugin);
            RegReadStr("ListDir", asListDir);
            Reg->CloseKey();
        }
        //[Options]
        if( Reg->OpenKey("\\Software\\SojinProject\\EasyView\\Options", false) ) {
            RegReadBool("Hide", cbHide->Checked);
            RegReadBool("FullScr", cbFull->Checked);
            RegReadBool("Now", cbNow->Checked);
            RegReadBool("Drag", cbDrag->Checked);
            RegReadBool("Repeat", cbRepeat->Checked);
            RegReadBool("Screen", mnuScreen->Checked);
                FormGrph->popScreen->Checked = mnuScreen->Checked;
	    	RegReadBool("Bell", mnuBell->Checked);
		    RegReadBool("Dialog", mnuDialog->Checked);
    		RegReadBool("Hint", mnuHint->Checked);
            RegReadInt("FileSel", FormFile->RadioGroupMulti->ItemIndex);
            RegReadInt("Interval", ScrollBarInterval->Position);
            RegReadBool("Help", bHelp);
            Reg->CloseKey();
        }
        Reg->Free();
    }
    #undef  RegReadInt
    #undef  RegReadStr
    #undef  RegReadBool
#else
    FILE *fp;

	//	ݒt@C̓ǂݍ
	asIniName = LExeName.ChgExt("ini");
    if( (!isShift()) && ((fp = fopen(asIniName.c_str(), "r")) != NULL) ) {
    	fclose(fp);
        IniFile = new TIniFile(asIniName);
		//[Frame]
        FormMain->Left = IniFile->ReadInteger("Frame", "Left", 0);
		FormMain->Width = IniFile->ReadInteger("Frame", "Width", 452);
        FormMain->Height = IniFile->ReadInteger("Frame", "Height", 380);
        FormMain->Top = IniFile->ReadInteger("Frame", "Top", 0);
        if( (FormMain->Left + FormMain->Width) > Screen->Width ) FormMain->Left = 0;
		if( (FormMain->Width) > Screen->Width) FormMain->Width = Screen->Width;
        if( (FormMain->Top + FormMain->Height) > Screen->Height ) FormMain->Top = 0;
        if( (FormMain->Height) > Screen->Height ) FormMain->Height = Screen->Height;
    	iColumnTmpWidth[0] = IniFile->ReadInteger("Frame", "LsColWid0", 128);
    	iColumnTmpWidth[1] = IniFile->ReadInteger("Frame", "LsColWid1", 40);
    	iColumnTmpWidth[2] = IniFile->ReadInteger("Frame", "LsColWid2", 40);
        //[General]
        asGrphDir = IniFile->ReadString("General", "Path", ".");
        #ifdef BCBDIALOG
        iFilterIndex = IniFile->ReadInteger("General", "Filter", 1);
        #else
		if(isPathExist(asGrphDir)) {
        	FormFile->DirectoryListBox1->Directory = asGrphDir;
			FormFile->DriveComboBox1->Drive = FormFile->DirectoryListBox1->Drive;
        }
        #endif
        asGrphMask = IniFile->ReadString("General", "GrphMask", asGrphFilter);
        if(asGrphMask == "") asGrphMask = asGrphFilter;
        asPager = IniFile->ReadString("General", "Pager", "");
        asDateFormat = IniFile->ReadString("General", "DateFormat", asDateFormat);
        asPlugin = IniFile->ReadString("General", "Plugin", "@");
        asListDir = IniFile->ReadString("General", "ListDir", "");
        //[Options]
        cbHide->Checked = IniFile->ReadBool("Options", "Hide", true);
        cbFull->Checked = IniFile->ReadBool("Options", "FullScr", false);
        cbNow->Checked = IniFile->ReadBool("Options", "Now", true);
        cbDrag->Checked = IniFile->ReadBool("Options", "Drag", true);
        cbRepeat->Checked = IniFile->ReadBool("Options", "Repeat", false);
        mnuScreen->Checked = IniFile->ReadBool("Options", "Screen", false);
            FormGrph->popScreen->Checked = mnuScreen->Checked;
		mnuBell->Checked = (IniFile->ReadBool("Options", "Bell", true));
		mnuDialog->Checked = (IniFile->ReadBool("Options", "Dialog", true));
		mnuHint->Checked = (IniFile->ReadBool("Options", "Hint", true));
        FormFile->RadioGroupMulti->ItemIndex = IniFile->ReadInteger("Options", "FileSel", 0);
        ScrollBarInterval->Position = IniFile->ReadInteger("Options", "Interval", 5);
        bHelp = IniFile->ReadBool("Options", "Help", false);
        delete IniFile;
    }
#endif
	//	wvEqg̐ݒEtH[JXƂ̏
	Application->HelpFile = LExeName.ChgExt("hlp");
	Application->OnHint = &ShowHint;
    Application->OnDeactivate = &AppDeactivate;
	// PlugIn fBNg̐ݒ
    if(asPlugin == "@") {
        asPlugin = LExeName.GetPath();
        if( LMessageBox(
                "@EasyView͒P̂ł BMP RLE WMF EMF ICO ̊ȩق\ł܂B"
                "̌`̉摜̧ق\邽߂ɂ́CΉ SUSIE Plugin(*.spi) KvłB"
                "EasyView.exeƓtH_ȊOPlugiņقuꍇɂ́C"
                "̃tH_w肷Kv܂B\r\n"
                "@PlugintH_ύX܂H\r\n"
                "@Őݒ肵ȂĂCu̧فvj[́uPluginݒvłłύXł܂B",
                "Plugin̐ݒ", MB_YESNO|MB_ICONINFORMATION|MB_DEFBUTTON2)
            == IDYES )
        {
            mnuPluginClick(Sender);
        }
    }
    InitPlugin(asPlugin.c_str());
	//	hbOAhhbv̏
    DragAcceptFiles(Handle, true);
    //	R}hC̎擾
    if(argc() > 1) {
        ListView->Items->Clear();
    	for(int i = 1; i < argc(); i++) {
			if( isCanDisp( argv(i) ) ) {
    			ListViewAdd( argv(i) );
            }
	    }
	}
	//	̑̏
    ListBoxDandD->Visible = false;
	ButtonFace();
    mnuWinG->Enabled = false;
    mnuWinT->Enabled = false;
    mnuScreen->Enabled = cbDrag->Checked;
        FormGrph->popScreen->Enabled = cbDrag->Checked;
    if(ListView->Items->Count > 0) {
		ButtonFace();
		bDisplayed = false;
		FormMain->Hint = ListViewPath(0);
		PicNr = 0;
		mnuGrphClick(NULL);
    } else {
    	/*
    	if(!cbHide->Checked) FormMain->Show();
		if(mnuDialog->Checked) mnuInsClick(Sender);
		if((!FormGrph->Visible)	&& (!FormMain->Visible)) FormMain->Show();
		*/
    	FormMain->Show();
		if(mnuDialog->Checked) mnuInsClick(Sender);
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormExit(TObject *Sender)
{
#ifdef USEREG
    //  WXgւ̏o
    if(!isShift()) {    // ShiftL[Ă΁CWXgύXI
        TRegistry *Reg = new TRegistry();
        Reg->RootKey = HKEY_CURRENT_USER;
        if(!isCtrl()) { // CtrlL[Ă΁CWXg폜ďI
            //[Frame]
            Reg->OpenKey("\\Software\\SojinProject\\EasyView\\Frame", true);
            Reg->WriteInteger("Left", FormMain->Left);
            Reg->WriteInteger("Top", FormMain->Top);
            Reg->WriteInteger("Width", FormMain->Width);
            Reg->WriteInteger("Height", FormMain->Height);
            Reg->WriteInteger("LsColWid0", ListView->Columns->Items[0]->WidthType);
            Reg->WriteInteger("LsColWid1", ListView->Columns->Items[1]->WidthType);
            Reg->WriteInteger("LsColWid2", ListView->Columns->Items[2]->WidthType);
            Reg->CloseKey();
            //[General]
            Reg->OpenKey("\\Software\\SojinProject\\EasyView\\General", true);
            Reg->WriteString("Path", asGrphDir);
            #ifdef BCBDIALOG
            Reg->WriteInteger("Filter", iFilterIndex);
            #endif
		    Reg->WriteString("GrphMask", asGrphMask);
    		Reg->WriteString("Pager", asPager);
            Reg->WriteString("DateFormat", asDateFormat);
            Reg->WriteString("Plugin", asPlugin);
            Reg->WriteString("ListDir", asListDir);
            Reg->CloseKey();
            //[Options]
            Reg->OpenKey("\\Software\\SojinProject\\EasyView\\Options", true);
            Reg->WriteBool("Hide", cbHide->Checked);
            Reg->WriteBool("FullScr", cbFull->Checked);
            Reg->WriteBool("Now", cbNow->Checked);
            Reg->WriteBool("Drag", cbDrag->Checked);
            Reg->WriteBool("Repeat", cbRepeat->Checked);
            Reg->WriteBool("Screen", mnuScreen->Checked);
            Reg->WriteBool("Bell", mnuBell->Checked);
            Reg->WriteBool("Dialog", mnuDialog->Checked);
            Reg->WriteBool("Hint", mnuHint->Checked);
            #ifndef BCBDIALOG
            Reg->WriteInteger("FileSel", FormFile->RadioGroupMulti->ItemIndex);
            #endif
            Reg->WriteInteger("Interval", ScrollBarInterval->Position);
            Reg->WriteBool("Help", bHelp);
            Reg->CloseKey();
        } else {
            Reg->DeleteKey("\\Software\\SojinProject\\EasyView");
        }
        Reg->Free();
    }
#else
	FILE *fp;

    //	ݒt@Cւ̏o
    if( (!isShift()) && ((fp = fopen(asIniName.c_str(), "a+")) != NULL) ) {
    	fclose(fp);
        IniFile = new TIniFile(asIniName);
		//[Frame]
        IniFile->WriteInteger("Frame", "Left", FormMain->Left);
        IniFile->WriteInteger("Frame", "Top", FormMain->Top);
        IniFile->WriteInteger("Frame", "Width", FormMain->Width);
        IniFile->WriteInteger("Frame", "Height", FormMain->Height);
        IniFile->WriteInteger("Frame", "LsColWid0", ListView->Columns->Items[0]->WidthType);
        IniFile->WriteInteger("Frame", "LsColWid1", ListView->Columns->Items[1]->WidthType);
        IniFile->WriteInteger("Frame", "LsColWid2", ListView->Columns->Items[2]->WidthType);
        //[General]
        IniFile->WriteString("General", "Path", asGrphDir);
        #ifdef BCBDIALOG
        IniFile->WriteInteger("General", "Filter", iFilterIndex);
        #endif
		IniFile->WriteString("General", "GrphMask", asGrphMask);
		IniFile->WriteString("General", "Pager", asPager);
        IniFile->WriteString("General", "DateFormat", asDateFormat);
        IniFile->WriteString("General", "Plugin", asPlugin);
        IniFile->WriteString("General", "ListDir", asListDir);
        //[Options]
        IniFile->WriteBool("Options", "Hide", cbHide->Checked);
        IniFile->WriteBool("Options", "FullScr", cbFull->Checked);
        IniFile->WriteBool("Options", "Now", cbNow->Checked);
        IniFile->WriteBool("Options", "Drag", cbDrag->Checked);
        IniFile->WriteBool("Options", "Repeat", cbRepeat->Checked);
        IniFile->WriteBool("Options", "Screen", mnuScreen->Checked);
        IniFile->WriteBool("Options", "Bell", mnuBell->Checked);
        IniFile->WriteBool("Options", "Dialog", mnuDialog->Checked);
        IniFile->WriteBool("Options", "Hint", mnuHint->Checked);
        IniFile->WriteInteger("Options", "FileSel", FormFile->RadioGroupMulti->ItemIndex);
        IniFile->WriteInteger("Options", "Interval", ScrollBarInterval->Position);
        IniFile->WriteBool("Options", "Help", bHelp);
        delete IniFile;
    }
#endif
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormClose(TObject *Sender, TCloseAction &Action)
{
	FormExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::WMDropFiles(TWMDropFiles Msg)
{
	int Count = DragQueryFile((HDROP)Msg.Drop, 0xFFFFFFFF, NULL, 255);
    char FileName[256];
    bool bAdded = false;

   	ListBoxDandD->Clear();
    for(int i = 0; i < Count; i++) {
		DragQueryFile((HDROP)Msg.Drop, i, FileName, 255);
        ListBoxDandD->Items->Add( FileName );
    }
    DragFinish((HDROP)Msg.Drop);
    if(ListBoxDandD->Items->Count > 0) {
        PicNr = ListView->Items->Count;
	    for(int i = 0; i < ListBoxDandD->Items->Count; i++ ) {
			if( isCanDisp( ListBoxDandD->Items->Strings[i] ) ) {
    			ListViewAdd( ListBoxDandD->Items->Strings[i] );
                bAdded = true;
            }
        }
        ButtonFace();
        if(bAdded) {
            FormMain->Hint = ListViewPath(PicNr);
	        bDisplayed = false;
	        for(int i = 0; i < iColumnNum; i++) bReverse[i] = false;
			if(cbNow->Checked) mnuGrphClick(NULL);
        }
	}
    Application->BringToFront();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ShowGrph(AnsiString FileName)
{
	LPathName LPathName(FileName);

	TWaitCursor wait;
    FormGrph->ShowGrph(FileName);
    StatusBar1->SimpleText = FileName;
    Application->Title = "EV - " + LPathName.GetName();
	if(ListView->SelCount > 0) {
		for(int i = 0; i < ListView->Items->Count; i++)
			ListView->Items->Item[i]->Selected = false;
	}
    ListView->Selected = ListView->Items->Item[PicNr];
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonFace()
{
	switch(ListView->Items->Count) {
    case 0 :
       	mnuGrph->Enabled = false;
        popGrph->Enabled = false;
        sbRight->Enabled = false;
        mnuDel->Enabled = false;
        sbDel->Enabled = false;
        mnuClear->Enabled = false;
        sbClear->Enabled = false;
		mnuMulti->Enabled = false;
        popMulti->Enabled = false;
        sbMulti->Enabled = false;
        FormGrph->popMulti->Enabled = false;
        mnuLeft->Enabled = false;
        sbLeft->Enabled = false;
        popLeft->Enabled = false;
        FormGrph->popNext->Enabled = false;
        FormGrph->popPrev->Enabled = false;
        mnuSave->Enabled = false;
    	break;
    case 1 :
       	mnuGrph->Enabled = true;
        popGrph->Enabled = true;
        sbRight->Enabled = true;
        mnuDel->Enabled = true;
        sbDel->Enabled = true;
        mnuClear->Enabled = true;
        sbClear->Enabled = true;
		mnuMulti->Enabled = false;
        popMulti->Enabled = false;
        sbMulti->Enabled = false;
        FormGrph->popMulti->Enabled = false;
        mnuLeft->Enabled = false;
        sbLeft->Enabled = false;
        popLeft->Enabled = false;
        FormGrph->popNext->Enabled = false;
        FormGrph->popPrev->Enabled = false;
        mnuSave->Enabled = true;
        break;
    default:
       	mnuGrph->Enabled = true;
        popGrph->Enabled = true;
        sbRight->Enabled = true;
        mnuDel->Enabled = true;
        sbDel->Enabled = true;
        mnuClear->Enabled = true;
        sbClear->Enabled = true;
		mnuMulti->Enabled = true;
        popMulti->Enabled = true;
        sbMulti->Enabled = true;
        FormGrph->popMulti->Enabled = true;
        mnuLeft->Enabled = true;
        sbLeft->Enabled = true;
        popLeft->Enabled = true;
        FormGrph->popNext->Enabled = true;
        FormGrph->popPrev->Enabled = true;
        mnuSave->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ShowHint(TObject *Sender)
{
    StatusBar1->SimpleText
   	   	= mnuHint->Checked ? Application->Hint : FormMain->Hint;
	if(FormText) {
		FormText->StatusBar1->Panels->Items[sbHint]->Text
       		= mnuHint->Checked ? Application->Hint : (AnsiString)"Hint[OFF]";
    }
    if(FormHint->Visible) {
		/*
    	POINT pos;
        GetCursorPos((LPPOINT)&pos);
		FormHint->Left = pos.x + 16;
	    FormHint->Top = pos.y - 96;
		*/
    	FormHint->LabelHint->Caption = Application->Hint;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::AppDeactivate(TObject *Sender)
{
    FormHint->FormDeactivate(Sender);
    FormGrph->FormDeactivate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::SetFocusToMenu()
{
	if(FormFile->Visible) FormFile->SetFocus();
    else if(FormMain->Visible) FormMain->SetFocus();
    else FormMain->Show();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::OutFocusFromMenu()
{
	if(cbHide->Checked) FormMain->Hide();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ListViewAdd(AnsiString FullPathName) {
	TListItem *itemNew;
    LPathName pathname(FullPathName);

	itemNew = ListView->Items->Add();
	itemNew->Caption = pathname.GetName();
    itemNew->SubItems->Add(pathname.GetExt().LowerCase());
	itemNew->SubItems->Add(pathname.GetPath());
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFormMain::ListViewName(int index)
{
	return ListView->Items->Item[index]->Caption;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFormMain::ListViewPath(int index)
{
	LPathName pathname(ListView->Items->Item[index]->Caption);
	return pathname.ChgPath(ListView->Items->Item[index]->SubItems->Strings[1]);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TFormMain::Timer1Timer(TObject *Sender)
{
	mnuGrphClick(Sender);
	if(ListView->Items->Count < 2)
		mnuMultiClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormKeyPress(TObject *Sender, char &Key)
{
	switch(Key) {
	case VK_ESCAPE: mnuExitClick(Sender); break;
	case VK_RETURN: mnuGrphClick(Sender); break;
    default : return;
    }
    Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormKeyDown(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
	if(Shift.Contains(ssCtrl)) {
		switch(Key) {
		case 'T': mnuTextClick(Sender); break;	//	VK_T
	    default : return;
	    }
    } else if(Shift.Contains(ssShift)) {
		switch(Key) {
	    case VK_DELETE: mnuClearClick(Sender); break;
		case 'F'	  : mnuFullClick(Sender); break;	//	VK_F
        case VK_HOME  : mnuWinTClick(Sender); break;
	    default : return;
	    }
    } else {
		switch(Key) {
	    case VK_INSERT: mnuInsClick(Sender); break;
	    case VK_DELETE: mnuDelClick(Sender); break;
        case VK_HOME  : mnuWinGClick(Sender); break;
	    case VK_SPACE :
	    	if(Timer1->Enabled) {
	        	FormMain->mnuMultiClick(Sender);
	        }
			break;
	    default : return;
	    }
	}
	Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuExitClick(TObject *Sender)
{
	 Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuTextClick(TObject *Sender)
{
#ifdef BCBDIALOG
	LPathName LGrphName(FormMain->Hint);
    AnsiString filters;

	if(FormText) {
		if(FormText->CloseQuery(Sender) == false) return;
    }
   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    if(FormMain->Hint == "") {
        filters = asTextFilters;
    } else {
        filters = "ţ(" + LGrphName.GetNode() + ".*)|"
                    + LGrphName.GetNode() + ".*|"
                    + asTextFilters;
	}
    OpenDialog->Title = "÷̧قJ";
    OpenDialog->HelpContext = FILEOPEN;
    OpenDialog->InitialDir = asGrphDir;
    OpenDialog->FileName = "";
    OpenDialog->Filter = filters;
    OpenDialog->FilterIndex = 1;
    OpenDialog->Options.Clear();
    OpenDialog->Options << ofShowHelp
        << ofFileMustExist;
    OpenDialog->Execute();
	if(OpenDialog->Files->Count > 0) {
        LPathName LPathName(OpenDialog->FileName);
        asGrphDir = LPathName.GetPath();
		if(asPager == "") {
			if(FormText == NULL) {
            	FormText = new TFormText(this);
            }
			FormText->RichEditText->Lines->LoadFromFile(OpenDialog->FileName);
            FormText->FileName = OpenDialog->FileName;
            FormText->RichEditText->Modified = false;
            FormText->StatusBar1->Panels->Items[sbChanged]->Text = "";
			FormText->Caption = "EasyView - " + OpenDialog->FileName;
			FormText->RichEditText->ReadOnly = OpenDialog->Options.Contains(ofReadOnly);
			if(FormText->RichEditText->ReadOnly) {
	    		FormText->StatusBar1->Panels->Items[sbChanged]->Text = "ǐ";
                FormText->mnuSave->Enabled = false;
            } else {
	    		FormText->StatusBar1->Panels->Items[sbChanged]->Text = "";
                FormText->mnuSave->Enabled = true;
			}
			FormText->mnuUndo->Enabled = false;
            FormText->popUndo->Enabled = false;
			FormText->Show();
    	} else {
			LSpawn(asPager, OpenDialog->FileName);
		}
    }
#else
	LPathName LPathName(FormMain->Hint);
    AnsiString mask,filters;

	if(FormText) {
		if(FormText->CloseQuery(Sender) == false) return;
    }
   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    if(FormMain->Hint == "") {
        mask = asTextFilter;
        filters = asTextFilters;
    } else {
    	mask = LPathName.GetNode() + ".*";
        filters = asTextFilters + LPathName.GetNode() + ".*\r\n";
	}
    FormFile->SetFileDialog(    //  Multi, Save, ReadOnly, FileList
        "÷̧قJ", FILEOPEN, false, false, true, true,
        mask, filters,
        "J(&O)", "I̧ق𕶏̧قƂĊJ܂");
    if( (FormFile->ShowModal() != mrCancel) && (isPathExist(FormFile->FileName)) ) {
		if(asPager == "") {
			if(FormText == NULL) {
            	FormText = new TFormText(this);
            }
			FormText->RichEditText->Lines->LoadFromFile(FormFile->FileName);
            FormText->FileName = FormFile->FileName;
            FormText->RichEditText->Modified = false;
            FormText->StatusBar1->Panels->Items[sbChanged]->Text = "";
			FormText->Caption = "EasyView - " + FormFile->FileName;
			FormText->RichEditText->ReadOnly = FormFile->cbReadOnly->Checked;
			if(FormText->RichEditText->ReadOnly) {
	    		FormText->StatusBar1->Panels->Items[sbChanged]->Text = "ǐ";
                FormText->mnuSave->Enabled = false;
            } else {
	    		FormText->StatusBar1->Panels->Items[sbChanged]->Text = "";
                FormText->mnuSave->Enabled = true;
			}
			FormText->mnuUndo->Enabled = false;
            FormText->popUndo->Enabled = false;
			FormText->Show();
    	} else {
			LSpawn(asPager, FormFile->FileName);
		}
    }
#endif
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ScrollBarIntervalChange(TObject *Sender)
{
	static char buf[6];
    sprintf(buf, "  %2d", ScrollBarInterval->Position);
	EditInterval->Text = buf;
    Timer1->Interval = ScrollBarInterval->Position * 1000;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::cbFullClick(TObject *Sender)
{
	mnuFull->Checked = cbFull->Checked;
    FormGrph->popFull->Checked = cbFull->Checked;
   	FormGrph->FullScreen(cbFull->Checked);
	bDisplayed = false;
    if(FormGrph->Visible) mnuGrphClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuMultiClick(TObject *Sender)
{
    Timer1->Enabled = !Timer1->Enabled;
	if(Timer1->Enabled) {
        mnuGrphClick(Sender);
		if( ListView->Items->Count < 2 ) {
        	Timer1->Enabled = false;
            return;
        }
    	mnuMulti->Checked = true;
        popMulti->Checked = true;
        sbMulti->Down = true;
        sbMulti->Hint = "摜̎\𒆎~܂";
		FormGrph->popMulti->Checked = true;
        FormGrph->Cursor = crAppStart;
    } else {
    	mnuMulti->Checked = false;
        popMulti->Checked = false;
        sbMulti->Down = false;
        sbMulti->Hint = "摜Iɏɕ\܂";
		FormGrph->popMulti->Checked = false;
        FormGrph->Cursor = crDefault;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuGrphClick(TObject *Sender)
{   //  ĕ\Ȃǂ̏ꍇ͈ NULL ČĂяo
	switch(ListView->Items->Count) {
   	case 0 : return;
   	case 1 : break;
   	default:
   		if(bDisplayed) {
			if( ++PicNr >= ListView->Items->Count )
               	PicNr = 0;
   	    	FormMain->Hint = ListViewPath(PicNr);
   		}
   	}
    ShowGrph(FormMain->Hint);
	bDisplayed = true;
    if(!cbHide->Checked) SetFocusToMenu();
	if( (Sender != NULL) && (PicNr == (ListView->Items->Count - 1)) ) {
		if(mnuBell->Checked) MessageBeep(MB_OK);
        if((!cbRepeat->Checked) && (Timer1->Enabled)) mnuMultiClick(Sender);
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuLeftClick(TObject *Sender)
{
	if(ListView->Items->Count < 2) return;
    if(--PicNr < 0) PicNr = ListView->Items->Count - 1;
    FormMain->Hint = ListViewPath(PicNr);
    ShowGrph(FormMain->Hint);
	bDisplayed = true;
    if(!cbHide->Checked) SetFocusToMenu(); //	FocusControl(sbRight);
	if( mnuBell->Checked && (Sender != NULL) && (PicNr == 0) ) MessageBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuVersionClick(TObject *Sender)
{
	LShowInfo(
    	"EasyView Ver.0.20\n"
        "    CopyLEFT(C) 1997, Masaaki(Jack)KAGEYAMA, SojinProject\n\n"
		"'EasyView' comes with ABSOLUTELY NO WARRANTY.\n"
		"This is free software, and you are welcome to redistribute it\n"
		"under certain conditions; for details read 'EasyView.txt'\n"
        "or contact\n\n"
		"\tMailto:pbc00345@niftyserve.or.jp\n"
        "\thttp://www.yo.rim.or.jp/~kageyama\n"
        "\thttp://www.asahi-net.or.jp/~lf5m-kgym\n\n"
        "This program was made with\n"
        "C++Builder : Copyright(C) 1997, Borland International, Inc.",
        "About...");
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuHideClick(TObject *Sender)
{
	cbHide->Checked = !mnuHide->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::cbHideClick(TObject *Sender)
{
	mnuHide->Checked = cbHide->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuFullClick(TObject *Sender)
{
	cbFull->Checked = !mnuFull->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuHintClick(TObject *Sender)
{
	mnuHint->Checked = !mnuHint->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuWinGClick(TObject *Sender)
{
	if(mnuWinG->Enabled == false) return;
	if(FormGrph->Visible) FormGrph->SetFocus();
    else FormGrph->Show();
    if(FormGrph->WindowState == wsMinimized) ShowWindow(FormGrph->Handle, SW_RESTORE);
}
//---------------------------------------------------------------------------;
void __fastcall TFormMain::StatusBar1DblClick(TObject *Sender)
{
	EditFileName->Text = FormMain->Hint;
	EditFileName->SelectAll();
    EditFileName->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ListViewClick(TObject *Sender)
{
	if(ListView->Selected) {
		PicNr = ListView->Selected->Index;
    	FormMain->Hint = ListViewPath(PicNr);
    	StatusBar1->SimpleText = FormMain->Hint;
    	bDisplayed = false;
    } else {
    	if(ListView->Items->Count > 0)
        	ListView->Selected = ListView->Items->Item[PicNr];
		LShowInfo(
			"̧ٖدƎɕ\摜ς܂\n"
			"̧ٖٸدƂ̉摜\܂\n\n"
			"قد\n"
			"دڂ𐳏^tɿĂ܂\n\n"
			"SHIFT܂܁AقدƗ̕\n"
			"    Iɒ適̫Ăɖ߂\n"
            "ƌ݂ɕς܂"
            ,"̧ٖȊȌꏊدƁAĂ\܂"
        );
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ListViewDblClick(TObject *Sender)
{
	ListViewClick(Sender);
	if(ListView->Selected) mnuGrphClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuInsClick(TObject *Sender)
{
#ifdef BCBDIALOG
   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    OpenDialog->Title = "摜̧قǉ";
    OpenDialog->HelpContext = FILEADD;
    OpenDialog->InitialDir = asGrphDir;
    OpenDialog->FileName = "";
    OpenDialog->Filter = asGrphFilters;
    OpenDialog->FilterIndex = iFilterIndex;
    OpenDialog->Options.Clear();
    OpenDialog->Options << ofShowHelp
        << ofAllowMultiSelect << ofFileMustExist << ofHideReadOnly;
    OpenDialog->Execute();
    iFilterIndex = OpenDialog->FilterIndex;
	if(OpenDialog->Files->Count > 0) {
        LPathName LPathName(OpenDialog->FileName);
        asGrphDir = LPathName.GetPath();
       	ListBoxDandD->Clear();
		for(int i = 0; i < OpenDialog->Files->Count; i++) {
			if( isCanDisp( OpenDialog->Files->Strings[i] ) ) {
                ListBoxDandD->Items->Add(OpenDialog->Files->Strings[i]);
            }
    	}
        if(ListBoxDandD->Items->Count > 0) {
            PicNr = ListView->Items->Count;
	        for(int i = 0; i < ListBoxDandD->Items->Count; i++ ) {
   			    ListViewAdd( ListBoxDandD->Items->Strings[i] );
            }
            ButtonFace();
            FormMain->Hint = ListViewPath(PicNr);
            bDisplayed = false;
            for(int i = 0; i < iColumnNum; i++) bReverse[i] = false;
            if(cbNow->Checked) mnuGrphClick(NULL);
    	}
    }
#else
	bool bAdded = false;

   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    FormFile->SetFileDialog(    //  Multi, Save, ReadOnly, FileList
        "摜̧قǉ", FILEADD, true, false, false, true,
        asGrphMask, asGrphFilters,
        "J(&O)", "I摜̧ق̧ؽĂɒǉ܂");
	if((FormFile->ShowModal() != mrCancel) && (FormFile->FileListBox1->SelCount > 0) ) {
		PicNr = ListView->Items->Count;
		for(int i = 0; i < FormFile->FileListBox1->Items->Count; i++) {
			if(FormFile->FileListBox1->Selected[i]) {
				if( isCanDisp( FormFile->ListFileName(i) ) ) {
                    ListViewAdd(FormFile->ListFileName(i));
					bAdded = true;
				}
        	}
    	}
        ButtonFace();
        if(bAdded) {
			FormMain->Hint = ListViewPath(PicNr);
	        bDisplayed = false;
	        for(int i = 0; i < iColumnNum; i++) bReverse[i] = false;
			if(cbNow->Checked) mnuGrphClick(NULL);
        }
        asGrphDir = FormFile->DirectoryListBox1->Directory;
    }
    asGrphMask = FormFile->ComboBoxFilter->Text;
#endif
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuDelClick(TObject *Sender)
{
    for(int i = 0; i < ListView->Items->Count; i++) {
    	if(ListView->Items->Item[i]->Selected) {
			ListView->Items->Delete(i);
			--i;
        }
    }
	PicNr = 0;
	if(ListView->Items->Count > 0) {
    	FormMain->Hint = ListViewPath(PicNr);
    } else {
		FormMain->Hint = "";
	}
    bDisplayed = false;
    ButtonFace();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuClearClick(TObject *Sender)
{
	ListView->Items->Clear();
	ButtonFace();
    bDisplayed = false;
	PicNr = 0;
    FormMain->Hint = "";
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuNowClick(TObject *Sender)
{
	cbNow->Checked = !mnuNow->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuRepeatClick(TObject *Sender)
{
	cbRepeat->Checked = !mnuRepeat->Checked;
    FormGrph->popRepeat->Checked = !mnuRepeat->Checked;
    mnuRepeat->Checked = !mnuRepeat->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::cbNowClick(TObject *Sender)
{
	mnuNow->Checked = cbNow->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::cbRepeatClick(TObject *Sender)
{
	mnuRepeat->Checked = cbRepeat->Checked;
    FormGrph->popRepeat->Checked = cbRepeat->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuWinTClick(TObject *Sender)
{
	if(mnuWinT->Enabled == false) return;
   	if(FormText->Visible) FormText->SetFocus();
    else FormText->Show();
    if(FormText->WindowState == wsMinimized) ShowWindow(FormText->Handle, SW_RESTORE);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	if(FormText) FormText->Close();
	CanClose = (FormText == NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::cbDragClick(TObject *Sender)
{
    FormGrph->popDrag->Checked = cbDrag->Checked;
	mnuDrag->Checked = cbDrag->Checked;
    mnuScreen->Enabled = cbDrag->Checked;
    FormGrph->popScreen->Enabled = cbDrag->Checked;
	bDisplayed = false;
    if(FormGrph->Visible) mnuGrphClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuDragClick(TObject *Sender)
{
	cbDrag->Checked = !mnuDrag->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuBellClick(TObject *Sender)
{
	mnuBell->Checked = !mnuBell->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuDialogClick(TObject *Sender)
{
	mnuDialog->Checked = !mnuDialog->Checked;	
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ListViewColumnClick(TObject *Sender,
	TListColumn *Column)
{
    bool bTemp;

	if(isShift()) {
	    if(Column->WidthType < 0) {
        	if(Column->Index == 2) {
			    iColumnDefWidth[2]
        			 = Width - 452 + 256
						- ListView->Columns->Items[0]->Width + 128
			            - ListView->Columns->Items[1]->Width +  40;
			    if(iColumnDefWidth[2] < 40) iColumnDefWidth[2] = 40;
            }
	    	Column->Width = iColumnDefWidth[Column->Index];
	    } else {
			Column->Width = -1;
	    }
    } else {
		if(ListView->Items->Count < 2) return;
		iColumnNr = Column->Index;
		ListView->SortType = stText;
		ListView->SortType = stNone;
        bTemp = bReverse[Column->Index];
        for(int i = 0; i < iColumnNum; i++) bReverse[i] = false;
        bReverse[Column->Index] = !bTemp;
		PicNr = 0;
		for(int i = 0; i < ListView->Items->Count; i++)
			ListView->Items->Item[i]->Selected = false;
		ListView->Selected = ListView->Items->Item[PicNr];
		FormMain->Hint = ListViewPath(0);
		bDisplayed = false;
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ListViewCompare(TObject *Sender, TListItem *Item1,
	TListItem *Item2, int Data, int &Compare)
{
	switch(iColumnNr) {
    case 0 :
		Compare = Item1->Caption.AnsiCompareIC(Item2->Caption);
        break;
    case 1 :
    	Compare
        = Item1->SubItems->Strings[0].AnsiCompareIC(Item2->SubItems->Strings[0]);
        break;
    case 2 :
    	Compare
        = Item1->SubItems->Strings[1].AnsiCompareIC(Item2->SubItems->Strings[1]);
        break;
	}
	if(bReverse[iColumnNr]) Compare = -Compare;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ListViewKeyUp(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
	switch(Key) {
    case VK_UP   : // No break
    case VK_DOWN :
		PicNr = ListView->Selected->Index;
    	FormMain->Hint = ListViewPath(PicNr);
    	StatusBar1->SimpleText = FormMain->Hint;
    	bDisplayed = false;
       	Key = 0;
        break;
    }

}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormResize(TObject *Sender)
{
	if(Width < 452) Width = 452;
    if(Height < 380) Height = 380;
    ListView->Width = Width - 452 + 444;
    ListView->Height = Height - 380 + 244;
    if(iColumnTmpWidth[0] > -3) {
		ListView->Columns->Items[0]->Width = iColumnTmpWidth[0];
		ListView->Columns->Items[1]->Width = iColumnTmpWidth[1];
		ListView->Columns->Items[2]->Width = iColumnTmpWidth[2];
		iColumnTmpWidth[0] = -3;
    }
    iColumnDefWidth[2]
         = Width - 452 + 256
			- ListView->Columns->Items[0]->Width + 128
            - ListView->Columns->Items[1]->Width +  40;
    if(iColumnDefWidth[2] < 40) iColumnDefWidth[2] = 40;
    if(ListView->Columns->Items[2]->WidthType > 0) {
    	ListView->Columns->Items[2]->Width = iColumnDefWidth[2];
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormActivate(TObject *Sender)
{
	if(Visible && FormHint->Visible) FormHint->Hide();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuIndexClick(TObject *Sender)
{
	if(bHelp)	Application->HelpCommand(HELP_FINDER, 0);	// New style
	else		Application->HelpCommand(HELP_INDEX, 0);	// Old style
	//	Application->HelpCommand(HELP_CONTEXT, FORMMAIN);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuKeywordClick(TObject *Sender)
{
	Application->HelpCommand(HELP_KEY, (long)((LPSTR)""));
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuScreenClick(TObject *Sender)
{
    FormGrph->popScreen->Checked = !(mnuScreen->Checked);
    mnuScreen->Checked = !(mnuScreen->Checked);
	bDisplayed = false;
    if(FormGrph->Visible) mnuGrphClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuPluginClick(TObject *Sender)
{
    AnsiString asTemp;

   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    asTemp = FormFile->DirectoryListBox1->Directory;
    FormFile->DirectoryListBox1->Directory = asPlugin;
    FormFile->SetFileDialog(    //  Multi, Save, ReadOnly, FileList
        "PlugIntH_̐ݒ", PLUGIN, false, false, false, false,
        "*.spi", "*.spi\r\n*.*\r\n",
        "&OK", "IĂިڸ؂PlugintH_ƂĐݒ肵܂");
    if(FormFile->ShowModal() != mrCancel) {
        asPlugin = FormFile->DirectoryListBox1->Directory;
        InitPlugin(asPlugin.c_str());
    }
    FormFile->DirectoryListBox1->Directory = asTemp;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuOpenClick(TObject *Sender)
{
#ifdef BCBDIALOG
    FILE *fp;
    char buf[_MAX_PATH], *sp;
	bool bAdded = false;

   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    OpenDialog->Title = "Xgt@Cǉ";
    OpenDialog->HelpContext = LISTOPEN;
    OpenDialog->InitialDir = asListDir;
    OpenDialog->FileName = "";
    OpenDialog->Filter = "EasyViewؽ̧(*.evl)|*.evl|SĂ̧(*.*)|*.*|";
    OpenDialog->FilterIndex = 1;
    OpenDialog->Options.Clear();
    OpenDialog->Options << ofShowHelp
        << ofFileMustExist << ofHideReadOnly;
    OpenDialog->Execute();
	if( (OpenDialog->Files->Count > 0)
        && ((fp = fopen(OpenDialog->FileName.c_str(), "rt")) != NULL) )
    {
        LPathName LPathName(OpenDialog->FileName);
        asListDir = LPathName.GetPath();
        asListFile = OpenDialog->FileName;
		PicNr = ListView->Items->Count;
		while(fgets((sp = buf), _MAX_PATH, fp)) {
            if(*sp) {
                sp += strlen(buf) - 1;
                if(*sp == '\n') *sp = 0;
			    if( isCanDisp(buf) && isPathExist(buf) ) {
                    ListViewAdd(buf);
				    bAdded = true;
        	    }
            }
    	}
        fclose(fp);
        ButtonFace();
        if(bAdded) {
			FormMain->Hint = ListViewPath(PicNr);
	        bDisplayed = false;
	        for(int i = 0; i < iColumnNum; i++) bReverse[i] = false;
			if(cbNow->Checked) mnuGrphClick(NULL);
        }
    }
#else
    AnsiString asTemp;
    FILE *fp;
    char buf[_MAX_PATH], *sp;
	bool bAdded = false;

   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    asTemp = FormFile->DirectoryListBox1->Directory;
    FormFile->DirectoryListBox1->Directory = asListDir;
    FormFile->SetFileDialog(    //  Multi, Save, ReadOnly, FileList
        "Xgt@Cǉ", LISTOPEN, false, false, false, true,
        "*.evl", "*.evl\r\n*.*\r\n",
        "J(&O)", "Iؽ̧ق摜̧قǉ܂");
	if( (FormFile->ShowModal() != mrCancel)
        && (FormFile->FileName != "")
        && ((fp = fopen(FormFile->FileName.c_str(), "rt")) != NULL) )
    {
        asListFile = FormFile->FileName;
		PicNr = ListView->Items->Count;
		while(fgets((sp = buf), _MAX_PATH, fp)) {
            if(*sp) {
                sp += strlen(buf) - 1;
                if(*sp == '\n') *sp = 0;
			    if( isCanDisp(buf) && isPathExist(buf) ) {
                    ListViewAdd(buf);
				    bAdded = true;
        	    }
            }
    	}
        fclose(fp);
        ButtonFace();
        if(bAdded) {
			FormMain->Hint = ListViewPath(PicNr);
	        bDisplayed = false;
	        for(int i = 0; i < iColumnNum; i++) bReverse[i] = false;
			if(cbNow->Checked) mnuGrphClick(NULL);
        }
    }
    asListDir = FormFile->DirectoryListBox1->Directory;
    FormFile->DirectoryListBox1->Directory = asTemp;
#endif
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::mnuSaveClick(TObject *Sender)
{
#ifdef BCBDIALOG
    FILE *fp;

   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    SaveDialog->Title = "Xgt@Cۑ";
    SaveDialog->HelpContext = LISTSAVE;
    SaveDialog->InitialDir = asListDir;
    SaveDialog->FileName = asListFile;
    SaveDialog->Filter = "EasyViewؽ̧(*.evl)|*.evl|SĂ̧(*.*)|*.*|";
    SaveDialog->FilterIndex = 1;
    SaveDialog->Options.Clear();
    SaveDialog->Options << ofShowHelp
        << ofHideReadOnly << ofNoReadOnlyReturn << ofOverwritePrompt;
    SaveDialog->Execute();
	if( (SaveDialog->Files->Count > 0) && (SaveDialog->FileName != "") ) {
        if((fp = fopen(SaveDialog->FileName.c_str(), "wt")) == NULL) {
            LMessageBox(
                "t@C܂",
                SaveDialog->FileName, MB_OK|MB_ICONSTOP );
        } else {
            LPathName LPathName(SaveDialog->FileName);
            asListDir = LPathName.GetPath();
            asListFile = SaveDialog->FileName;
            for(int i = 0; i < ListView->Items->Count; i++) {
                if( (fputs(ListViewPath(i).c_str(), fp) == EOF)
                    || (fputc('\n', fp) == EOF) )
                {
                    LMessageBox(
                        "Ō܂ŏ߂܂ł",
                        asListFile, MB_OK|MB_ICONSTOP );
                    break;
                }
            }
            fclose(fp);
        }
    }
#else
    AnsiString asTemp;
    FILE *fp;

   	if(Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    asTemp = FormFile->DirectoryListBox1->Directory;
    FormFile->DirectoryListBox1->Directory = asListDir;
    FormFile->SetFileDialog(    //  Multi, Save, ReadOnly, FileList
        "t@CXgۑ", LISTOPEN, false, true, false, true,
        "*.evl", "*.evl\r\n*.*\r\n",
        "ۑ(&S)", "t@CXgۑ܂");
    FormFile->FileListBox1->FileName = asListFile;
	if( (FormFile->ShowModal() != mrCancel) && (FormFile->FileName != "") ) {
        if( !isPathExist(FormFile->FileName)
            || ( LMessageBox(
                    "̧قɑ݂܂B㏑܂H",
                    FormFile->FileName, MB_YESNO|MB_ICONQUESTION)
                == IDYES ) )
        {
            if((fp = fopen(FormFile->FileName.c_str(), "wt")) == NULL) {
                LMessageBox(
                    "t@C܂",
                    FormFile->FileName, MB_OK|MB_ICONSTOP );
            } else {
                asListFile = FormFile->FileName;
                for(int i = 0; i < ListView->Items->Count; i++) {
                    if( (fputs(ListViewPath(i).c_str(), fp) == EOF)
                        || (fputc('\n', fp) == EOF) )
                    {
                        LMessageBox(
                            "Ō܂ŏ߂܂ł",
                            FormFile->FileName, MB_OK|MB_ICONSTOP );
                        break;
                    }
                }
                fclose(fp);
            }
        }
    }
    asListDir = FormFile->DirectoryListBox1->Directory;
    FormFile->DirectoryListBox1->Directory = asTemp;
#endif
}
//---------------------------------------------------------------------------



