//---------------------------------------------------------------------------
#ifndef UnitTextH
#define UnitTextH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Dialogs.hpp>
//---------------------------------------------------------------------------
class TFormText : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TRichEdit *RichEditText;
	TMainMenu *MainMenuText;
	TMenuItem *mnuFile;
	TMenuItem *mnuClose;
	TMenuItem *mnuWin;
	TMenuItem *mnuMenu;
	TPopupMenu *PopupMenu1;
	TMenuItem *popCut;
	TMenuItem *mnuExit;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *popUndo;
	TMenuItem *mnuEdit;
	TMenuItem *mnuCut;
	TMenuItem *mnuCopy;
	TMenuItem *mnuPaste;
	TMenuItem *N3;
	TMenuItem *mnuDel;
	TMenuItem *mnuAll;
	TMenuItem *mnuWrap;
	TMenuItem *N4;
	TMenuItem *mnuDate;
	TMenuItem *N5;
	TMenuItem *mnuUndo;
	TMenuItem *mnuSearch;
	TMenuItem *mnuFind;
	TMenuItem *mnuNext;
	TMenuItem *popCopy;
	TMenuItem *popPaste;
	TMenuItem *N6;
	TMenuItem *popAll;
	TMenuItem *popDel;
	TFindDialog *FindDialog1;
	TReplaceDialog *ReplaceDialog1;
	TMenuItem *mnuReplace;
	TStatusBar *StatusBar1;
	TMenuItem *mnuOpen;
	TMenuItem *popMenu;
	TMenuItem *mnuSaveAs;
	TMenuItem *mnuSave;
	TMenuItem *mnuHelp;
	TMenuItem *mnuIndex;
	TMenuItem *mnuKeyword;
	void __fastcall FormKeyPress(TObject *Sender, char &Key);
	void __fastcall FormDblClick(TObject *Sender);

	void __fastcall mnuCloseClick(TObject *Sender);
	void __fastcall mnuMenuClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormHide(TObject *Sender);
	
	
	
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	
	
	
	void __fastcall mnuExitClick(TObject *Sender);
	
	void __fastcall mnuUndoClick(TObject *Sender);
	void __fastcall mnuCutClick(TObject *Sender);
	void __fastcall mnuCopyClick(TObject *Sender);
	void __fastcall mnuPasteClick(TObject *Sender);
	void __fastcall mnuDelClick(TObject *Sender);
	void __fastcall mnuAllClick(TObject *Sender);
	void __fastcall mnuDateClick(TObject *Sender);
	void __fastcall mnuWrapClick(TObject *Sender);
	void __fastcall mnuFindClick(TObject *Sender);
	void __fastcall mnuNextClick(TObject *Sender);
	
	void __fastcall mnuReplaceClick(TObject *Sender);
	
	void __fastcall FindDialog1Find(TObject *Sender);
	void __fastcall ReplaceDialog1Find(TObject *Sender);
	
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall RichEditTextChange(TObject *Sender);
	
	
	
	
	
	
	
	void __fastcall mnuOpenClick(TObject *Sender);
	
	void __fastcall FormActivate(TObject *Sender);
	
	void __fastcall ButtonFace(TObject *Sender);
	void __fastcall ReplaceDialog1Replace(TObject *Sender);
	void __fastcall mnuSaveClick(TObject *Sender);
	void __fastcall mnuSaveAsClick(TObject *Sender);
	void __fastcall mnuKeywordClick(TObject *Sender);
	void __fastcall mnuIndexClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
private:	// [U[錾
	int __fastcall TFormText::SaveAs(TObject *Sender);
public:		// [U[錾
	__fastcall TFormText(TComponent* Owner);
	bool __fastcall CloseQuery(TObject *Sender);
	AnsiString FileName;
};
//---------------------------------------------------------------------------
extern TFormText *FormText;
extern const int sbChanged;
extern const int sbInsert;
extern const int sbHint;
extern AnsiString asDateFormat;
//---------------------------------------------------------------------------
#endif
